/* substr() as defined in AWK, called with as: substr(str, from [,len]) */
static void bi_substr(fawk_ctx_t *ctx, const char *fname, int argc, fawk_cell_t *retval)
{
	fawk_cell_t *str = FAWK_CFUNC_ARG(0), *from = FAWK_CFUNC_ARG(1), *len, dummy;

	if ((argc != 2) && (argc != 3)) return;

	fawk_cast_to_str(ctx, str);
	fawk_cast_to_num(ctx, from);

	if (argc > 2) {
		len = FAWK_CFUNC_ARG(2);
		fawk_cast_to_num(ctx, len);
	}
	else {
		len = &dummy;
		len->data.num = str->data.str->used;
	}

	/* offset 'from' to start indexing from 1, and clamp it in range of the string length */
	if (--from->data.num < 0) from->data.num = 0;
	if (from->data.num > str->data.str->used) from->data.num = str->data.str->used;

	retval->type = FAWK_STR;
	retval->data.str = fawk_str_new_from_literal(ctx, str->data.str->str + (long)from->data.num, len->data.num);
}

/* install it using: fawk_symtab_regcfunc(ctx, "substr", bi_substr); */
